      PROGRAM FORDAP
C     FORDAP FOURIER CALCULATION ROUTINE
C     FREE FORMAT VERSION USING SUBROUTINE FREEIN
C     THE FOLLOWING CHANGES COULD BE MADE:
C    THIS PROGRAM IS NOW IN A TRANSITIONAL STAGE
C     THE TRANS SUBROUTINE HAS BEEN MODIFIED TO INCLUDE NON-ORTHOGONAL CELLS
C     IN THE TRANSFORMED CELL
C    ACCORDINGLY THE FOLLOWING CHANGES HAVE BEEN MADE TO THIS SUBROUTINE
C
C     1.  7 FORMAT  BY WHICH THE PLANE EQUATION AND TRANSFORMED CELL CONSTANTS
C    ARE READ IS NOW 10F8.5   THE EXTRA THREE LOCATIONS BEING THE ANGLE COSINES
C
C    2. STATEMENT 3 NOW READS CELL(J), J=1,6
C
C     3.  STATEMENT 12 NO LONGER SETS CELL4-6 EQUAL TO ZERO
C     ZALKIN FORDAP MODIFIED BY IBERS FOR BNL SYSTEM AUG. 1962
C     SLIGHTLY CLEANED UP MARCH 1967
C     NU VERSION 16NOV1965
C     UC VERSION BY BRIGHT JAN1969
C     MODIFIED TO DO BOUNDED PROJECTION MARCH 1969
C
C     1) FURTHER MODIFIED IN SUBROUTINES FRPEAK,SIG100 AND PARAM
C        LIST IN SETU .. NOV78 (STARS AROUND CHANGES)
C
C     2) THIS IS THE   **** 2980 **** VERSION.
C        NOTE THAT INTEGERS AND REALS MUST BE THE SAME LENGTH
C        FOR THE HORRIBLE COMMON BLOCK TO WORK OK
C        THIS MEANS CHANGES IN FRPEAK AND BLOCK DATA
C
C         ALSO NOTE COMMENT AT BEGINNING OF RIP
C
C
C
C
      DIMENSION TRGTBL(1001),ISST(20),NDATA(11404),WORDS(20)
      DIMENSION U(3,3),DUMMY(13092)
      COMMON TRGTBL,NORIEN,NXX,NYZ,NZ,XMIN,
     1 XMAX,YMIN,YMAX,ZMIN,ZMAX,DX,DY,
     1  DZ,AMAX,BMAX,JMAX,KMAX,KMIN,NMEMMX,NEGINA,NCD,NEF,NEFTBL,NX,NY,
     2  NCUE,N1,RMAX,NLAST,NFPLT,YFL,N11,IN,III,IVXX,IXX,NN2,NN3,NN5,
     3  ISST,A,B,C,COSA,COSB,COSC,NSEC,NGRID,NSKIP,CNTRNO,CNTNEG,
     4  NEXPAN,WORDS,NDATA
      EQUIVALENCE(TRGTBL(1),DUMMY(1))
C
C     CLEAR COMMON BLOCK
      DO 1 I= 1,13092
  1   DUMMY(I) = 0.
      FNEG= 1.0
      CALL SETUP
      IF(ISST(2))63,65,63
  63  CALL TRANS(U,DETU)
  65  IF(ISST(1))42,42,64
  64  CALL RIP(U)
      CALL SIG100
  42  IF(ISST(3))43,44,43
  43  CALL FRPRNT
  44  IF(ISST(4))45,46,45
  45  CALL FRPEAK(FNEG,U,DETU)
C     LIST NEGATIVE PEAKS IF NEUTRON INPUT
C     IF(ISST(12)) 46,50,46
   50 FNEG= -1.0
      CALL FRPEAK(FNEG,U,DETU)
   46 IF(ISST(5)) 47,62,47
  47  CALL FRPLOT
   62 IF(ISST(14)) 70,70,66
   66 CONTINUE
  70  STOP
      END
      SUBROUTINE CHEKUP(XMIN,XMAX,NORIEN,N,DX)
  1   DIFFX = XMAX - XMIN
      IF(DIFFX) 3,20,5
  3   XMIN = XMAX
      XMAX = XMIN - DIFFX
      GO TO 1
  5   IF(DIFFX - 1. ) 30,10,10
  10  XMAX = .5
      XMIN = -.5
      GO TO 60
  20  NORIEN = N
      DX = .001
      GO TO 60
  30  IF(XMAX - 1.) 60,40,40
  40  XMIN = -.5
      XMAX = XMIN +DIFFX
  60  RETURN
      END
      SUBROUTINE FRPEAK(FNEG,U,DETU)
C     LISTS 1000 ORB ISST(7)*100 BIGGEST PEAKS IN DECREASING ORDER
      DIMENSION R(1010,3),XX(1003),YY(1003),ZZ(1003),NNX(1003),NNY(1003)
     1  ,NNZ(1003),RR(1003),TRGTBL(1014),ISST(20),RRR(250),NNNX(250),
     2 NNNY(250),NXPREV(250),RRPREV(250),NYPREV(250),EXCESS(12),
     3  WORDS(20),SPACE(5)
      DIMENSION U(3,3),V(3,3),XKIM(3)
      COMMON TRGTBL,AMAX,BMAX,EXCESS,RMAX,NLAST,YFPLT,YFL,N11,IN,III,
     1  IVXX,IXX,NN2,NN3,NN5,ISST,A,B,C,COSA,COSB,COSC,SPACE,NEXPAN,
     2  WORDS,R,XX,YY,ZZ,NNX,NNY,NNZ,RR,RRR,NNNX,NNNY,NXPREV,NYPREV,
     3  RRPREV
      COMMON /PETE/ RKEEP
C
  1   FORMAT(1H0,20A4)
 1001 FORMAT(41H0 FRPEAK DOES NOT WORK ON SINGLE SECTIONS)
  406 FORMAT(66H FOURPEAK AS WRITTEN FILTERS A MAXIMUM OF 250 PEAKS PER
     1SECTION.                   ///)
  516 FORMAT(46H FRPEAK IS LIMITED TO A SEARCH OF 1000 PEAKS.      )
  703 FORMAT(50H0     LIST OF PEAK POSITIONS AND THEIR HEIGHTS    //
     251H    ED=ELECTRON DENSITY (IN E/A**O IF INPUT DATA   /
     347H     ARE IN ELECTRONS)=(2./VOL)*(RMAX/999.)*RHO/
     460H IF LISTED, X(A) ETC REFER TO NEW CELL B WITH B2 PARALLEL A2/
     551H        B1 PARALLEL TO A2XA3,  B3 PARALLEL TO B1XB2///)
  716 FORMAT(52H  NO.     X       Y       Z      RHO     ED(E/A**3)   )
  717 FORMAT(52H  NO.     X       Z       Y      RHO     ED(E/A**3)   )
  718 FORMAT(52H  NO.     Z       Y       X      RHO     ED(E/A**3)   )
 3309 FORMAT(46H0TRANSFORMATION MATRICES - X(A)=U X-- X=V X(A))
 3310 FORMAT(9H0U MATRIX)
 3311 FORMAT(3(1H0,3E12.5/))
 3312 FORMAT(9H0V MATRIX)
 7193 FORMAT(1H ,73X,24H    OLDX    OLDY    OLDZ                )
 9106 FORMAT(1H ,73X,36H    X(A)  Y(A)    Z(A)      D(000)    )
 9107 FORMAT(1H0 )
  810 FORMAT(1H ,I3,3F8.4,I8,4H   (,F12.3,1H))
 8107 FORMAT(1H ,73X,3F8.3,5X,F8.3)
C
      VOL = A*B*C*SQRT(1.-COSA**2-COSB**2-COSC**2+2.*COSA*COSB*COSC)
      LP = 0
      WRITE (III,1)(WORDS(K),K=1,20)
      REWIND IVXX
      RMIN = (-1.E20)*FNEG
      JLAST = 0
      IF(ISST(7))51,52,51
  52  LT = 1000
      GO TO 53
  51  LT = 100*ISST(7)
  53  L = 0
      NZ = 0
      DO 70 M=1,250
      RRR(M) = RMIN
      NNNX(M) =0
      NNNY(M) = 0
      NXPREV(M) = 0
      RRPREV(M) = RMIN
  70  NYPREV(M) = 0
      ASSIGN 100 TO NEWDAT
      ASSIGN 250 TO INDATA
 2076 READ(IVXX)CODE,RMAX
      IF(CODE)2077,2078,2078
 2078 READ(IVXX)
      GO TO 2076
 2077 REWIND IVXX
      READ(IVXX)CODE
      GO TO 115
  100 READ(IVXX) CODE
      IF(CODE)108,200,110
 108  ASSIGN 700 TO NEWDAT
      GO TO 111
 110  ASSIGN 640 TO NEWDAT
 111  ASSIGN 240 TO INDATA
      GO TO 200
  115 READ(IVXX) NX,NY,XMIN,XMAX,DELTAX,ZMAX,Z,NXIS,YMIN,YMAX,DY,
     2  AMAX,BMAX,DZ,ZMIN,NZNZNZ
      IF(ZMAX-ZMIN)1000,1000,2
 1000 WRITE (III,1001)
      RETURN
  2   NXX = NX + 2
      DO 120 K=1,3
      DO 120 I=1,NXX
  120 R(I,K) = RMIN
      NZ = NZ +1
      NXXX = NX +1
      J = 0
      NYN = 0
      GO TO 100
 200  DO 220 I = 1,NXX
      R(I,1) = R(I,2)
  220 R(I,2) = R(I,3)
      Y = Y + DY
      GO TO INDATA, (250,240)
  240 DO 245 I = 2,NXXX
  245 R(I,3) = RMIN
      ASSIGN 250 TO INDATA
      GO TO 290
  250 READ (IVXX)Y,(R(I,3),I=2,NXXX)
      Y = Y - DY
  290 X = XMIN - DELTAX
      NYN = NYN + 1
  305 DO 590 I=2,NXXX
      X = X + DELTAX
      JJ = I-1
      JJJ = I + 1
      DO 320 M =JJ,JJJ
      DO 320 K = 1,3
      IF(FNEG*(R(I,2)-R(M,K))) 590,320,320
  320 CONTINUE
  400 J = J + 1
      IF(J-250)408,408,405
  405 WRITE(III,406)
      J = J - 1
      GO TO 591
  408 RRR(J) = R(I,2)
      NNNX(J) = I-1
      NNNY(J) = NYN
  409 DO 430 M = 1,JLAST
      NEWY = IABS  (NYN-NYPREV(M))
      IF(NEWY-1) 410,410,430
  410 NEWX =  IABS   (I-1-NXPREV(M))
      IF(NEWX-1)415,415,430
  415 IF(FNEG*(R(I,2)-RRPREV(M)))590,440,440
  430 CONTINUE
  440 DO 480 K=1,L
      IF(NZ-NNZ(K)-1) 480,450,480
  450 NEWY =  IABS  (NYN - NNY(K))
      IF(NEWY-1) 460,460,480
  460 NEWX =  IABS  (I - 1 - NNX(K))
      IF(NEWX-1) 470,470,480
  470 IF(FNEG*(R(I,2) - RR(K)))590,475,475
  475 XX(K) = X
      YY(K) = Y
      ZZ(K) = Z
      RR(K) = R(I,2)
      NNX(K) = I - 1
      NNY(K) = NYN
      NNZ(K) = NZ
      GO TO 590
  480 CONTINUE
  510 L = L + 1
      IF(L-1000)520,520,515
  515 WRITE (III,516)
      GO TO 700
  520 XX(L) = X
      YY(L) = Y
      ZZ(L) = Z
      RR(L) = R(I,2)
      NNX(L) = I - 1
      NNY(L) = NYN
      NNZ(L) = NZ
  590 CONTINUE
  591 GO TO NEWDAT,(100,640,700)
  640 ASSIGN 100 TO NEWDAT
      JLAST = J
      DO 680 I = 1,JLAST
      RRPREV(I) = RRR(I)
      NXPREV(I) = NNNX(I)
  680 NYPREV(I) = NNNY(I)
      GO TO 115
  700 REWIND IVXX
      WRITE (III,703)
 7031 IF(NXIS-10)705,706,707
  705 WRITE (III,716)
      GO TO 719
  706 WRITE (III,717)
      GO TO 719
  707 WRITE (III,718)
  719 IF(ISST(2))7192,7191,7192
 7192 WRITE (III,7193)
      GO TO 7194
 7191 DETU = 1.
      WRITE (III,9106)
      CALL SETU(U,A,B,C,COSA,COSB,COSC)
C*******************************************************
      CALL MI3(U,V,DETA)
C*******************************************************
 7194 WRITE (III,9107)
      IF(RMAX.LT.RKEEP) RMAX=RKEEP
      CONST = 999./RMAX
      LL = 0
  725 DO 740 K = 1,L
      IF(FNEG*(RR(K)-RMIN)) 740,740,730
  730 ICE = K
      RBIG = RR(K)
      GO TO 760
  740 CONTINUE
      GO TO 880
  760 DO 780 K=1,L
      IF(FNEG*(RBIG-RR(K))) 770,780,780
  770 RBIG = RR(K)
      ICE = K
  780 CONTINUE
      LL = LL + 1
      RR(ICE) = RMIN
      NPR = RBIG*CONST + .5
      RBED = 2.*RBIG*DETU/VOL
      IF(ISST(4)-1)30,30,916
  30  IF(  ABS  (XX(ICE) - XMAX) - .0005)725,725,911
  911 IF(  ABS  (XX(ICE) - XMIN) - .0005)725,725,912
  912 IF(  ABS  (YY(ICE) - YMAX) - .0005)725,725,913
  913 IF(  ABS  (YY(ICE) - YMIN) - .0005) 725,725,914
  914 IF(  ABS  (ZZ(ICE) - ZMAX) - .0005) 725,725,915
  915 IF(  ABS  (ZZ(ICE) - ZMIN) - .0005) 725,725,916
  916 LP = LP + 1
      WRITE (III,810)LP,XX(ICE),YY(ICE),ZZ(ICE),NPR,RBED
 8101 IF(NXIS-10)8103,8104,8105
 8104 CALL ROTATE(YY(ICE),ZZ(ICE))
      GO TO 8103
 8105 CALL ROTATE(XX(ICE),ZZ(ICE))
C**********************************************************
 8103 DO 8106 KIM1=1,3
 8106 XKIM(KIM1)=V(1,KIM1)*XX(ICE) + V(2,KIM1)*YY(ICE) +
     &               V(3,KIM1)*ZZ(ICE)
C********************************************************
      IF(ISST(2))9108,9109,9108
 9109 DPAT=SQRT(XKIM(1)**2+XKIM(2)**2+XKIM(3)**2)
      GO TO 9110
 9108 DPAT = 0.
 9110 WRITE (III,8107)(XKIM(KIM1),KIM1=1,3),DPAT
 8102 IF(LP-LT)725,880,880
  880 IF(ISST(2).EQ.0) GO TO 3307
      GO TO 3308
 3307 WRITE (III,3309)
      WRITE (III,3310)
      WRITE (III,3311)((U(I,J),I=1,3),J=1,3)
      WRITE (III,3312)
      CALL MI3(U,V,DETA)
      WRITE (III,3311)((V(I,J),I=1,3),J=1,3)
 3308 RETURN
      END
      SUBROUTINE FRPLOT
C     CONTOUR PRINT ROUTINE
      INTEGER BLANK
      DIMENSION RNEW1(29),RNEW2(29),RNEW3(29),NSYM(21),NEW(120)
      DIMENSION X(51),RR(51,51)        ,Y(60),TRGTB(1001),       IX2(51)
      DIMENSION IX1(51),WORDS(20),OUT(51),ISST(20)
      COMMON TRGTB ,NXIS,NXX,NYX,NZ,XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,
     1  DELTA ,DY,DZ,AMAX,BMAX,JMAX,KMAX,KMIN,NMEMM ,NEGIN ,NCD,NEF,
     2 NEFTB ,NX,NY,NCUE,N1,RMAX,NLAST,NFPLT,YFL,N11,NN1,III,IVXX,IXX,
     3  NN4,NN5,NN6,ISST,
     4 AXXX,BXXX,CXXX,COSA,COSB,COSC,NSEC,NGRID,NSKIP,CNTRN ,CNTNE ,    FR7T  0
     5 NEXPA ,WORDS,INDAT,NWXX,NVXX,NR,X,Y,RR
      COMMON /PETE/ RKEEP
C
      COMMON /INPUT/ NREAD,NPOINT,IRED,MODE,LINO,IDISML,
     1  ICHARS(14),ICARD(80),READIN(50)
C
      DIMENSION IREDIN(50)
C
      EQUIVALENCE (READIN(1),IREDIN(1))
C
      DATA ALPHX/4H X =/
      DATA ALPHY/4H Y =/
      DATA ALPHZ/4H Z =/
      DATA BLANK/1H /
C     360 CHARACTER CODES FOR 0,1'2,3'4,5'6,7'8,9'+
      DATA NSYM(1)/'0'/,NSYM(2)/','/,NSYM(3)/'1'/,NSYM(4)/''''/,
     &  NSYM(5)/'2'/,NSYM(6)/','/,NSYM(7)/'3'/,NSYM(8)/''''/,
     &  NSYM(9)/'4'/,
     &  NSYM(10)/','/,NSYM(11)/'5'/,NSYM(12)/''''/,NSYM(13)/'6'/,
     &  NSYM(14)/','/,NSYM(15)/'7'/,NSYM(16)/''''/,NSYM(17)/'8'/,
     &  NSYM(18)/','/,NSYM(19)/'9'/,NSYM(20)/''''/,NSYM(21)/'+'/
C
C     DATA STATEMENTS ABOVE OK FOR I4 OR I8 VERSION
C
C     DATA STATEMENTS BELOW FOR I4 VERSION ONLY
C
C     DATA NSYM/'0   ,   1   ''   2   ,   3   ''   4   ,   5   ''   6
C    1,   7   ''   8   ,   9   ''   +   '/
C
 2235 FORMAT(1H1,    20A4,12X,13H SECTION PART,I3)
  303 FORMAT(14H              ,29A4)
 3001 FORMAT(/)
  300 FORMAT(6H RMAX=,E13.6,35H                                  *,A6,
     1     F8.5,36H*                                C =     ,E13.6     )
 3025 FORMAT(A4,F8.5,3X,113A1)
 2125 FORMAT(1H     )
 2225 FORMAT(1H1)
 3012 FORMAT(14H              ,29(1X,I3))
  101 FORMAT(19H1PLOT CONTOURS FROM,F10.2,3H TO,F10.2,16H IN INTERVALS OFRPT,
     2F,  F10.2,/,34H (THE MAXIMUM PEAK HEIGHT IS 1000))
  103 FORMAT(21H0SUPPRESS APOSTROPHES)
  102 FORMAT(16H0SUPPRESS ZEROES)
  104 FORMAT(1H0,I5,42H CONTOURS REQUESTED. MAXIMUM ALLOWED IS 21)
C
	READ(NN1,*) CMAX,CMIN,CINT
	READ(NN1,*) NCHOS 
      WRITE(III,101)CMIN,CMAX,CINT
      IF(NCHOS)1602,1603,1602
 1603 NSYM(1)=BLANK
      WRITE(III,102)
 1601 GO TO 1602
 1602 NCONT=(CMAX-CMIN)/CINT+1
      IF(NCONT-21)1605,1605,1606
 1606 WRITE(III,104)NCONT
      STOP
 1605 CMINT=CMAX-CINT*20
      CMID=(CMAX+CMINT)/2.
      N=21-NCONT
      IF(N)1609,1609,1610
 1610 DO 1607 I=1,N
 1607 NSYM(I)=BLANK
 1609 SCALE=10./(CMAX-CMID)
      NPRT= ISST(9)
      IF(NPRT)4,4,5
    4 NPRT=26
      GO TO 6
    5 IF(NPRT-26)6,6,4
  6   CONTINUE
 5999 REWIND IVXX
  196 CONTINUE
  200 READ(IVXX)CODE,RMAX
      IF(CODE)202,201,201
  201 READ(IVXX)
      GO TO 200
  202 IF(RMAX.LT.RKEEP) RMAX=RKEEP
      C=1000./RMAX
  310 REWIND IVXX
 2281 READ(IVXX)CODE
  228 IF(CODE)219,207,203
  203 READ(IVXX)               NX,NY,XMIN,XMAX,DELTA,ZMAX,Z,NXIS,YMIN,
     2  YMAX,DY,AMAX,BMAX,DZ,ZMIN,NZ
      DO 440 I = 1,NY
      READ(IVXX)
      READ(IVXX)               Y(I),(RR(K,I),K=1,NX)
      DO 440 K=1,NX
      RR(K,I)=C*RR(K,I)-CMID
  440 CONTINUE
      DO 204 J=2,NX
  405 X(1) = XMIN
  204 X(J) = X(J-1) + DELTA
      IF(NXIS-10)2041,2042,2043
 2041 CHARZ=ALPHZ
      CHARX=ALPHX
      CHARY=ALPHY
      GO TO 2044
 2042 CHARX=ALPHX
      CHARY=ALPHZ
      CHARZ=ALPHY
      GO TO 2044
 2043 CHARX=ALPHZ
      CHARY=ALPHY
      CHARZ=ALPHX
 2044 DO 2045 J=1,NX
      OUT(J)=CHARX
      IX1(J)=INT(100.0*X(J)+CIGN(0.1,X(J)))
      IPETE=INT( 100000.0*X(J)+CIGN(0.1,X(J)))
 2045 IX2(J)=IABS(IPETE)-IABS(1000*IX1(J))
  207 NP=1
      IPAGE=1
      NQ=NPRT
  216 IF(NX-NQ)98,218,218
  98  NQ = NX
  218 NXX=(NQ-NP+1)*4-3
      WRITE(III,2235)(WORDS(K),K=1,20),IPAGE
      WRITE(III,3001)
      WRITE(III,300)RMAX,CHARZ,Z,C
      WRITE(III,3001)
      WRITE(III,2125)
      WRITE(III,303)(OUT(K),K=NP,NQ)
      WRITE(III,3012)(IX1(K),K=NP,NQ)
      WRITE(III,3012)(IX2(K),K=NP,NQ)
      WRITE(III,2125)
  450 Y1=Y(1)
      NNX=NQ-NP+1
      DO 1802 I=1,NNX
      N=I+NP-1
 1802 RNEW1(I)=RR(N,1)
      CALL EXPAN(RNEW1,NEW,NXX,SCALE)
      CALL SYMB(NEW,NXX,NSYM)
      WRITE(III,3025)CHARY,Y1,(NEW(KK),KK=1,NXX)
      DO 1803 I=2,NY
      Y3=Y(I)
      DO 1804 J=1,NNX
      N=J+NP-1
      RNEW3(J)=RR(N,I)
 1804 RNEW2(J)=(RNEW1(J)+RNEW3(J))/2.
      Y2=(Y1+Y3)/2.
      CALL EXPAN(RNEW2,NEW,NXX,SCALE)
      CALL SYMB(NEW,NXX,NSYM)
      WRITE(III,3025)CHARY,Y2,(NEW(KK),KK=1,NXX)
      CALL EXPAN(RNEW3,NEW,NXX,SCALE)
      CALL SYMB(NEW,NXX,NSYM )
      WRITE(III,3025)CHARY,Y3,(NEW(KK),KK=1,NXX)
      Y1=Y3
      DO 1805 K=1,NNX
 1805 RNEW1(K)=RNEW3(K)
 1803 CONTINUE
  480 IF(NX-NQ)2281,2281,485
  485 NP = NP + NPRT -1
      NQ = NQ + NPRT
      IPAGE=IPAGE+1
      GO TO 216
  219 REWIND IVXX
      RETURN
      END
      SUBROUTINE EXPAN(RIN,NOUT,NXX,SCALE)
C     EXPANDS ONE LINE OF MAP TO FILL ALL PRINT POSITIONS
      DIMENSION RIN(29),NOUT(120),ROUT(120)
      NX=(NXX+3)/4-1
      N=0
      DO 1 I=1,NX
      J=0
  2   N=N+1
      ROUT(N)=RIN(I)+(RIN(I+1)-RIN(I))*J/4
      J=J+1
      IF(J-4)2,1,1
  1   CONTINUE
      ROUT(NXX)=RIN(NX+1)
      DO 3 I=1,NXX
  3   NOUT(I)=SCALE*ROUT(I)
      RETURN
      END
      SUBROUTINE SYMB(NEW,NXX,NSYM)
C     ASSIGNS SYMBOLS FOR FRPLOT
      DIMENSION NSYM(21),NEW(120)
      DO 1 I=1,NXX
      N=NEW(I)+11
      IF(N-21)5,5,6
  6   N=21
  5   IF(N-1)8,7,7
  8   N=1
  7   NEW(I)=NSYM(N)
  1   CONTINUE
      RETURN
      END
      SUBROUTINE FRPRNT
C     PRINTS MAP
      DIMENSION X(1001),NR(101,101),ISST(20),Y(101),TRGTBL(1001)
     1  ,RR(101),IX2(29),IX1(29),WORDS(20)
      DIMENSION SS(5099),NSS(5102)
      COMMON TRGTBL,NXIS,NXX,NYX,NZ,XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,
     1  DELTAX,DY,DZ,AMAX,BMAX,JMAX,KMAX,KMIN,NMEMMX,NEGINA,NCD,NEF,
     2 NEFTBL,NX,NY,NCUE,N1,RMAX,NLAST,NFPLT,YFL,N11,NN1,III,IVXX,IXX,
     3  NN4,NN5,NN6,ISST,
     4 AXXX,BXXX,CXXX,COSA,COSB,COSC,NSEC,NGRID,NSKIP,CNTRNO,CNTNEG,
     5 NEXPAN,WORDS,NR,X,Y,RR
      COMMON /PETE/ RKEEP
      EQUIVALENCE (SS,NR(1)),(NSS,NR(5100))
      DATA ALPHAX,ALPHAY,ALPHAZ/4H X = ,4H Y = ,4H Z = /
C
  303 FORMAT(14H                   ,29A4   )
  302 FORMAT(3H Y=,F8.5,3H            ,29I4)
 3021 FORMAT(3H Z=,F8.5,3H            ,29I4)
 3001 FORMAT(/)
  300 FORMAT(6H RMAX=,E13.6,35H                                  *,A6,
     1     F8.5,36H*                                C =     ,E13.6     )
 2125 FORMAT(1H     )
 2225 FORMAT(1H1)
 3012 FORMAT(14H                          ,29(1X,I3))
C
      NPRT= ISST(9)
      IF(NPRT)4,4,5
  4   NPRT = 26
      GO TO 6
  5   IF(NPRT-26)6,6,4
  6   IF(ISST(6)-2)1,2,1
  1   ISZ=1
      GO TO 5510
  2   ISZ=2
 5510 IF(AMAX+BMAX)5999,1901,5999
 1901 AMAX = 1000.
 5999 REWIND IVXX
  196 CONTINUE
  200 READ(IVXX)CODE,RMAX
      IF(CODE)202,201,201
  201 READ(IVXX)
      GO TO 200
  202 IF(RMAX.LT.RKEEP) RMAX=RKEEP
      C=999./RMAX
  310 REWIND IVXX
 2281 READ (IVXX)CODE
  228 IF(CODE)219,207,203
  203 READ (IVXX)NX,NY,XMIN,XMAX,DELTAX,ZMAX,Z,NXIS,YMIN,YMAX,DY,
     1  AMAX,BMAX,DZ,ZMIN,NZ
      IF(NX-101)6023,6023,404
 6023 IF(NY-101)400,400,404
  404 NVAR = 0
      GO TO 405
  400 NVAR = 1
      DO 440 I = 1,NY
      READ (IVXX)
      READ (IVXX)Y(I),(RR(J),J=1,NX)
      DO 440 K=1,NX
      IF(RR(K))438,439,439
  438 NR(K,I)=C*RR(K) - 0.5
      GO TO 4401
  439 NR(K,I)=C*RR(K) + 0.5
 4401 IF(ISST(13).EQ.1.AND.NR(K,I).LT.0) NR(K,I) =0
  440 CONTINUE
  405 DO 204 J=2,NX
 1405 X(1) = XMIN
  204 X(J) = X(J-1) + DELTAX
      WRITE (III,2225)
      WRITE (III,3001)
      IF(NXIS-10)2041,2042,2043
 2041 CHAR = ALPHAZ
      GO TO 2044
 2042 CHAR = ALPHAY
      GO TO 2044
 2043 CHAR = ALPHAX
 2044 WRITE (III,300)RMAX,CHAR,Z,C
      WRITE(III,3001)
  207 NP = 1
      NQ = NPRT
  216 IF(NX-NQ)98,218,218
  98  NQ = NX
  218 IF(NXIS-10)2181,2181,2182
 2181 CHAR = ALPHAX
      GO TO 2183
 2182 CHAR = ALPHAZ
 2183 WRITE (III,303) (CHAR,I=1,NPRT)
      DO 3 J=NP,NQ
      K = 1 +    MOD  (J-1,NPRT)
      IX1(K) =   INT  (100.0*X(J) +  CIGN   (0.1,X(J)))
  3   IX2(K) =   INT    (100000.*  ABS  (X(J))+.1) - 1000*  IABS (IX1(K)
     1  )
      NNP = 1  +   MOD  (NP-1,NPRT)
      NNQ = 1 +   MOD  (NQ-1,NPRT)
      WRITE (III,3012)(IX1(K),K=NNP,NNQ)
      WRITE (III,3012)(IX2(K),K=NNP,NNQ)
      WRITE (III,2125)
      IF(NVAR)213,213,450
  450 IF(NXIS-10) 459,469,459
  459 IF(ISZ-1)460,460,486
  486 DO 487 I = 1,NY
      WRITE (III,302)Y(I),(NR(J,I),J=NP,NQ)
  487 WRITE (III,2125)
      GO TO 480
  460 DO 462 I=1,NY
  462 WRITE (III,302)Y(I),(NR(J,I),J=NP,NQ)
      GO TO 480
  469 IF(ISZ-1)470,470,488
  488 DO 489 I=1,NY
      WRITE (III,3021)Y(I),(NR(J,I),J=NP,NQ)
  489 WRITE (III,2125)
      GO TO 480
  470 DO 472 I=1,NY
  472 WRITE (III,3021)Y(I),(NR(J,I),J=NP,NQ)
  480 IF(NX-NQ)2281,2281,485
  485 WRITE (III,2225)
      NP = NP + NPRT
      NQ = NQ + NPRT
      GO TO 216
  213 DO 2123 N=1,NY
      I=1
      READ (IVXX)
  211 READ (IVXX)Y(1),(SS(J),J=1,NX)
      DO 212 J=NP,NQ
      IF(SS(J))230,231,231
  230 NSS(J)=C*SS(J) - 0.5
      GOTO 2121
  231 NSS(J)=C*SS(J) + 0.5
 2121 IF(ISST(13).EQ.1.AND.NSS(J).LT.0) NSS(J)=0
  212 CONTINUE
      IF(NXIS-10)2111,2112,2111
 2111 IF(ISZ-1)1000,1000,1001
 1000 WRITE (III,302)Y(I),(NSS(J),J=NP,NQ)
      GO TO 2123
 1001 WRITE (III,302)Y(I),(NSS(J),J=NP,NQ)
      WRITE (III,2125)
      GO TO 2123
 2112 IF(ISZ-1)1002,1002,1003
 1002 WRITE (III,3021)Y(I),(NSS(J),J=NP,NQ)
      GO TO 2123
 1003 WRITE (III,3021)Y(I),(NSS(J),J=NP,NQ)
      WRITE (III,2125)
 2123 CONTINUE
  214 IF(NX-NQ)2281,2281,217
  217 WRITE (III,2225)
      NBSP = NY + NY
      DO 220 M=1,NBSP
  220 BACKSPACE IVXX
      NP=NP+NPRT
      NQ=NQ+NPRT
      GO TO 216
  219 REWIND IVXX
C      END OF SUBROUTINE
      RETURN
      END
      SUBROUTINE GP1(PLANE,D,AA,U)
      DIMENSION PLANE(3),A(6),U(3,3),AA(3,3),BB(3,3),U1(3),U2(3),U3(3)
C     SUBROUTINE TO FIND TRANSFORMATION MATRIX TO AXES APPROPRIATE
C     TO PLANE INPUT
C     CELL2 = U*CELL1
C     CELL2(1) = NORMAL TO PLANE
C     SET UP METRICS
C
      CALL MI3(AA,BB,DETA)
      IF(D)4,3,3
  4   DO 5 I=1,3
  5   PLANE(I) = -PLANE(I)
      D = -D
  3   ALPHA = 1./SQRT(VMV(PLANE,BB,PLANE))
      DO 6I=1,3
  6   PLANE(I)=ALPHA*PLANE(I)
      D=ALPHA*D
C     PLANE IS NOW NORMALIZED WITH POSITIVE D
      CALL VM(PLANE,BB,U1)
C     U1 IS UNIT VECTOR PERPENDICULAR TO PLANE
      K = 1
      IF(  ABS  (PLANE(1)) - ABS  (PLANE(2)))7,8,8
  8   K = 2
  7   IF(  ABS  (PLANE(K)) -  ABS  (PLANE(3)))9,10,10
  10  K = 3
  9   FACTOR = -  CIGN  (PLANE(K),U1(K))
      DO 11 I=1,3
      IF (I-K)12,13,12
  13  U2(I) = 1. + FACTOR*U1(I)
      GO TO 11
  12  U2(I) = FACTOR*U1(I)
  11  CONTINUE
      CALL NORM (AA,U2)
C     SECOND VECTOR NOW NORMALIZED
      CALL CROSS(BB,U1,U2,U3)
      CALL NORM(AA,U3)
C     NOW HAVE ORTHONORMAL SET
      DO 1 I=1,3
      U(1,I) = U1(I)
      U(2,I) = U2(I)
  1   U(3,I) = U3(I)
      RETURN
      END
      FUNCTION JZRTST(K)
      IF(K)1,2,2
  1   JZRTST = -1
      RETURN
  2   JZRTST = 1
      RETURN
      END
      SUBROUTINE MI3(A,AI,D)
C     3X3 MATRIX AI = INVERSE OF 3X3 MATRIC A
      DIMENSION A(3,3),AI(3,3)
      DO 3 I=1,3
      K = 1 +   MOD  (I+1,3)
      M = 1 +   MOD  (I+3,3)
      DO 3 J=1,3
      L = 1 +   MOD  (J+1,3)
      N = 1 +   MOD  (J+3,3)
  3   AI(I,J) = A(L,K)*A(N,M)-A(L,M)*A(N,K)
      D = 0.
      DO 1 I=1,3
  1   D = D + A(I,1)*AI(1,I)
      DO 2 I=1,3
      DO 2 J=1,3
  2   AI(I,J) = AI(I,J)/D
      RETURN
      END
      SUBROUTINE MV(A,B,C)
C     VECTOR C = MATRIX A X VECTOR B
      DIMENSION A(3,3),B(3),C(3)
      DO 2 I=1,3
      C(I) = 0.
      DO 2 J=1,3
  2   C(I) = A(I,J)*B(J) + C(I)
      RETURN
      END
      SUBROUTINE NORM(AA,U)
C     OUTPUT VECTOR U = UNIT VECTOR PARALLEL WITH INPUT VECTOR U
      DIMENSION AA(3,3),U(3)
      ALPHA = SQRT(1./VMV(U,AA,U))
      DO 1 I=1,3
  1   U(I) = ALPHA*U(I)
      RETURN
      END
      SUBROUTINE CROSS(BB,A,B,C)
C     VECTOR C = CROSS PRODUCT OF VECTORS A AND B.  BB IS METRIC
      DIMENSION A(3),B(3),C(3),AI(6),BI(6),CI(6),BB(3,3)
      DO 115 I=1,3
      AI(I) = A(I)
      AI(I+3)=A(I)
      BI(I) = B(I)
  115 BI(I+3) = B(I)
      DO 119 I=1,3
  119 CI(I) = AI(I+1)*BI(I+2) - AI(I+2)*BI(I+1)
      CALL MV(BB,CI,C)
      RETURN
      END
      SUBROUTINE RIP(U)
C     EXPANDS INPUT UNIQUE DATA SET TO GENERATE ALL OF SPHERE
      DIMENSION MTX(24),MTY(24),MTZ(24),M1(24,3),M2(24,3),M3(24,3),
     1        J(24),K(24),L(24),A(24),B(24),RN(3),WORDS(20),
     2  JX(24),KX(24),LX(24),AX(24),BX(24),TRGTBL(1001),ISST(20),
     3  U(3,3),G(3,3),COUGH (9)
C
C     THIS IS NECESSARY FOR I8 VERSION TO READ INT*4 VALUE FROM
C     RIETVELD INPUT FILE .. NB THE PROG SHOULD BE COMPILED WITH
C     LEN = I8&J4 FOR THIS TO WORK
C
      INTEGER*4 NZZZZ,JJZZZZ,KKZZZZ,LLZZZZ
C
      COMMON TRGTBL,NORIEN,NXX,NYX,NZ,XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,
     1 DX,DY,DZ,AMAX,BMAX,JMAX,KMAX,KMIN,NMEMMX,NEGINA,NCD,NEF,NEFTBL,
     2  NX,NY,NCUE,N1,RMAX,NLAST,NFPLT,YFL,N11,IN,III,IVXX,IXX,NN5,
     3  NN6,NDATAP,ISST,AXX,BXX,C,COSA,COSB,COSC,NSEC,NGRID,NSKIP,CNTRNO
     4  ,CNTNEG,NEXPAN,WORDS,MTX,MTY,MTZ,J,K,L,A,B,JX,KX,LX,AX,BX,M1,M2,
     6  M3,RN,RD,G,COUGH
C
      COMMON /INPUT/ NREAD,NPOINT,IRED,MODE,LINO,IDISML,
     1  ICHARS(14),ICARD(80),READIN(50)
C
      DIMENSION SM(3,3),IREDIN(50)
C
      EQUIVALENCE (READIN(1),IREDIN(1))
      DATA TIT1,TIT2,TIT3,TIT4/4H TAP,4HE 17,4H CAR,4HDS  /
C
   40 FORMAT(1H0,38X,20HEQUIVALENT POSITIONS/
     1  1H ,20X,15HROTATION MATRIX,34X,
     2  18HTRANSLATION VECTOR)
   50 FORMAT(1H ,9I6,6X,3F12.6)
  88  FORMAT(20H0INPUT DATA IS FROM ,2A4//)
  91  FORMAT(13H X GOES FROM ,F8.5,4H TO ,F8.5,13H IN STEPS OF ,F8.5 /
     1       13H Y GOES FROM ,F8.5,4H TO ,F8.5,13H IN STEPS OF ,F8.5 /
     2       13H Z GOES FROM ,F8.5,4H TO ,F8.5,13H IN STEPS OF ,F8.5 /
     3 16H ORIENTATION IS ,I3,1H./
     4 39H NO. OF EQUIVALENT REFLECTIONS (HKL) =          ,I2/
     5  6H LIST ,I5,13H REFLECTIONS.                  ///)
  203 FORMAT(3I5,5X,2F10.2,2F10.7,F10.2)
 3008 FORMAT(50X,45H(THE INDICES ARE TRANSFORMED BY THE U MATRIX)      )
  115 FORMAT(39H0     H     K     L      A         B        )
  116 FORMAT(39H0     H     L     K      A         B        )
  117 FORMAT(39H0     L     K     H      A         B        )
  305 FORMAT(1H ,3I6,2F10.2)
  306 FORMAT(1H  )
 2000 FORMAT(31H0NO INPUT DATA = NO CALCULATION)
 2001 FORMAT(43H0THERE ARE NO EXPANDED DATA-END CALCULATION)
  352 FORMAT(5H THE ,I5,47H INDEPENDENT REFLECTIONS HAVE BEEN EXPANDED T
     1O , I6,8H TERMS.           ///)
  355 FORMAT(23H THE CD TABLE REQUIRES ,I5,14H MEMORY UNITS.  //       )
  357 FORMAT(23H THE EF TABLE REQUIRES ,I5,14H MEMORY UNITS.    ///)
  361 FORMAT(36H THE MAXIMUM SIZE OF THE EF TABLE IS ,I5,57H MEMORY UNIT
     1S.  THE PROGRAM WILL SPLIT EACH SECTION INTO ,I2,7H PARTS.      /)
  381 FORMAT(/)
  382 FORMAT(1H    )
 3306 FORMAT(19H PARITY ERROR AFTER,3I5)
 4008 FORMAT(47H0INSUFFICIENT STORAGE AVAILABLE. TERMINATE JOB.        )
91269 FORMAT(18H INDICES ARE WRONG)
 1080 FORMAT(6I5)
C
      IBEG= 1
      IF(ISST(12)) 2346,2346,2347
 2346 NREAD= 5
      N= 0
      GO TO 2348
 2347 NREAD= 6
      N= 1
 2348 IRED= 1
	READ(IN,*)(IREDIN(I),I=1,NREAD)
      NREF= IREDIN(N+1)
      NTAPIN= IREDIN(N+2)
      NONTAP= IREDIN(N+3)
      NREJ= IREDIN(N+4)
      NDON= IREDIN(N+5)
      IF(ISST(12)) 2351,2351,2350
 2350 NEQUIV= IREDIN(1)
      GO TO 2352
 2351 READ(NDATAP) NZZZZ
      NEQUIV = NZZZZ
 2352 WRITE (III,1080)NEQUIV,NREF,NTAPIN,NONTAP,NREJ
      NTAPSV=NTAPIN
      IF(NTAPIN-100)3002,3002,3000
 3000 NTAPIN = NTAPIN - 100
      GO TO 3002
 3002 IF(NTAPIN-10)18,16,16
  16  IF(NONTAP)18,17,18
  17  NONTAP=10000
  18  REWIND IXX
      REWIND IVXX
      NEXPAN = 0
      NTOTAL = 0
      AMAX = 0.
      BMAX = 0.
      NZERO = 0
      JMAX = 0
      KMAX = 0
      KMIN = 0
  81  IF(NTAPIN-1)85,84,84
  84  WORD1 = TIT1
      WORD2= TIT2
      GO TO 87
  85  WORD1 = TIT3
      WORD2 = TIT4
  87  WRITE (III,88)WORD1,WORD2
      IF(ISST(2)-1)3003,3003,3004
C     READ LIMITS, INCREMENTS, AND DIRECTION OF SUMMATION
 3003 NREAD= 9
 	READ(IN,*)(READIN(IJJ),IJJ=1,NREAD)
      XMIN= READIN(1)
      XMAX= READIN(2)
      YMIN= READIN(3)
      YMAX= READIN(4)
      ZMIN= READIN(5)
      ZMAX= READIN(6)
      DX= READIN(7)
      DY= READIN(8)
      DZ= READIN(9)
       NREAD= 1
 	READ(IN,*) IREDIN(1)
       IF(IREDIN(1)-1) 2641,2641,2642
 2641 NORIEN= 1
      GO TO 3005
 2642 NORIEN= IREDIN(1)
      GO TO 3005
 3004 NORIEN = 100
 3005 CALL CHEKUP(XMIN,XMAX,NORIEN,100,DX)
      CALL CHEKUP(YMIN,YMAX,NORIEN, 10,DY)
      CALL CHEKUP(ZMIN,ZMAX,NORIEN,  1,DZ)
 104  WRITE(III,91)XMIN,XMAX,DX,YMIN,YMAX,DY,ZMIN,ZMAX,DZ,NORIEN,
     1 NEQUIV,NREF
      IF(NORIEN-10)98,96,94
  94  CALL ROTATE(XMIN,ZMIN)
      CALL ROTATE(XMAX,ZMAX)
      CALL ROTATE(DX,DZ)
      GO TO 98
  96  CALL ROTATE(YMIN,ZMIN)
      CALL ROTATE(YMAX,ZMAX)
      CALL ROTATE(DY,DZ)
  98  IF(ISST(1).NE.2) GO TO 981
      DELTAZ = ZMAX - ZMIN
      ZMIN = (ZMAX+ZMIN)/2.
      ZMAX = ZMIN
      DZ = 1.
  981 NX = (XMAX-XMIN)/DX + 1.001
      NY = (YMAX-YMIN)/DY + 1.001
      NZ = (ZMAX-ZMIN)/DZ + 1.001
      WRITE(III,40)
C     READ IN SYMMETRY OPERATIONS
  122 DO 139 I=1,NEQUIV
      IF(ISST(12)) 30,20,30
   20 READ(NDATAP) ((SM(N,JJJ),JJJ=1,3),RN(N),N=1,3)
      DO 12345 N=1,3
      M1(I,N)= SM(N,1) +CIGN(0.5,SM(N,1))
      M2(I,N)= SM(N,2) +CIGN(0.5,SM(N,2))
      M3(I,N)= SM(N,3) +CIGN(0.5,SM(N,3))
12345 CONTINUE
      GO TO 6128
   30 IDISML= 1
      NREAD= 9
	READ(IN,*)(IREDIN(IIJ),IIJ=1,NREAD)
      M= 1
      DO 916 N=1,3
      M1(I,N)= IREDIN(M)
      M2(I,N)= IREDIN(M+1)
      M3(I,N)= IREDIN(M+2)
      M= M +3
  916 CONTINUE
      NREAD= 3
 	READ(IN,*)(READIN(IJJ),IJJ=1,3)
       DO 917 N=1,3
      RN(N)= READIN(N)
  917 CONTINUE
 6128 WRITE(III,50) (M1(I,N),M2(I,N),M3(I,N),N=1,3),(RN(N),N=1,3)
      IF(M1(I,1)+M2(I,1))170,400,170
  400 IF(M1(I,1))171,179,171
  170 IF(M1(I,2)+M2(I,2))179,401,179
  401 IF(M1(I,2))171,179,171
C     HEXAGONAL SITUATIONS
  171         IF(M1(I,1)+M2(I,2))173,172,173
  172         NSAVE = M2(I,1)
              M2(I,1)=M1(I,2)
              M1(I,2) = NSAVE
              GO TO 179
  173         NSAVE = M2(I,2)
              M2(I,2)=M1(I,1)
              M1(I,1)=NSAVE
  179 DO 129 M=1,3
  132 IF(RN(M))133,129,129
  133 RN(M) = 1. + RN(M)
      GO TO 132
  129 CONTINUE
      MTX(I)= 12.*RN(1) + .1
      MTY(I)=12.*RN(2) + .1
      MTZ(I)=12.*RN(3) + .1
  139 CONTINUE
  110 IF(NREF)111,201,111
  111 IF(NORIEN-10)112,113,114
  112 WRITE (III,115)
      GO TO 3006
  113 WRITE (III,116)
      GO TO 3006
  114 WRITE (III,117)
 3006 IF(ISST(2)-1)201,3007,3007
 3007 WRITE (III,3008)
 201  IF(NTAPIN-10)202,199,180
  180 IF(NONTAP)320,320,181
  181 NONTAP = NONTAP - 1
 3305 READ(NDATAP,END=320,ERR=3307) JJZZZZ,KKZZZZ,LLZZZZ,
     &  FOBS,SFCALC,COSAA,SINAA,DEL
      JJ = JJZZZZ
      KK = KKZZZZ
      LL = LLZZZZ
      IF(JJ.EQ.999) GO TO 320
      GO TO 141
 3307 WRITE (III,3306)JJ,KK,LL
  141 IF(NTAPSV-100)1004,1004,1005
 1005 FOBS = SQRT(FOBS)
      SFCALC = SQRT(SFCALC)
      DEL = FOBS - SFCALC
      GO TO 1004
 1004 IF(NTAPIN-21) 183,184,185
  183 AA = DEL*COSAA
      BB = DEL*SINAA
      GO TO 204
  184 IF(FOBS)183,180,183
  185 IF(NTAPIN-23)186,187,154
  186 AA = FOBS*COSAA
      BB = FOBS*SINAA
      GO TO 204
  187 AA = SFCALC*COSAA
      BB = SFCALC*SINAA
      GO TO 204
  154 IF(NTAPIN-25)155,156,2989
  155 AA=FOBS**2
      BB = 0.
      GO TO 204
  156 AA = SFCALC**2
      BB = 0.
      GO TO 204
 2989 AA = FOBS**2*SFCALC*COSAA
      BB = FOBS**2*SFCALC*SINAA
      GO TO 204
  199 IF(NONTAP)320,320,6123
 6123 NONTAP = NONTAP-1
 3301 READ(NDATAP,END=320,ERR=3303) JJZZZZ,KKZZZZ,LLZZZZ,
     &  FOBS,SFCALC,COSAA,SINAA,DEL
      JJ = JJZZZZ
      KK = KKZZZZ
      LL = LLZZZZ
      GO TO 6124
 3303 WRITE(III,3306) JJ,KK,LL
 6124 IF(FOBS)6125,6123,6125
 6125 AA =FOBS
      BB=0.
      GO TO 204
C     READ REFLECTION DATA IF ON CARDS
  202 READ(IN,203) JJ,KK,LL,FOBS,SFCALC,COSAA,SINAA,DEL
      IF(NDON) 2163,2164,2165
 2163 AA= FOBS*COSAA
      BB= FOBS*SINAA
      GO TO 2166
 2164 AA= DEL*COSAA
      BB= DEL*SINAA
      GO TO 2166
 2165 AA= FOBS*FOBS
      BB= 0.0
 2166 IF(JJ-999)204,320,320
  204 IF(AA)206,205,206
  205 IF(BB)206,201,206
  206 IF(NREJ)212,210,212
  212 CALL REJECT(JJ,KK,LL,FOBS,SFCALC,COSAA,SINAA,DEL,NSKIP,AA,BB)
      IF(NSKIP)201,210,201
  210 NTOTAL = NTOTAL + 1
      IF(JJ)211,207,211
  207 IF(KK)211,208,211
  208 IF(LL)211,209,211
  209 AA = AA/2.
      BB = BB/2.
  211 IF(IABS(JJ)+IABS(KK)+IABS(LL).GT.200) GO TO 91268
      GO TO 91267
91268 WRITE(III,91269)
      GO TO 91270
91267 IF(ISST(8))91265,91266,91265
91265 WRITE(III,203)JJ,KK,LL,AA,BB
C     APPLY SYMMETRY OPERATIONS TO INDICES
91266 DO 254 N=1,NEQUIV
  217 J(N) = M1(N,1)*JJ + M2(N,1)*KK + M3(N,1)*LL
      K(N) = M1(N,2)*JJ + M2(N,2)*KK + M3(N,2)*LL
      L(N) = M1(N,3)*JJ + M2(N,3)*KK + M3(N,3)*LL
      NU=J(N)*MTX(N) + K(N)*MTY(N) + L(N)*MTZ(N)
      CALL TRIG(XCOS,XSIN,NU)
      A(N)=AA*XCOS-BB*XSIN
      B(N)=BB*XCOS + AA*XSIN
      IF(ISST(2)-1)224,3012,3012
 3012 FJX=J(N)
      FKX=K(N)
      FLX=L(N)
      WALJ=(U(1,1)*FJX+U(1,2)*FKX+U(1,3)*FLX)
      WALK=(U(2,1)*FJX+U(2,2)*FKX+U(2,3)*FLX)
      WALL=(U(3,1)*FJX+U(3,2)*FKX+U(3,3)*FLX)
      J(N) = WALJ + CIGN(0.5,WALJ)
      K(N)=WALK + CIGN(0.5,WALK)
 3010 L(N) = WALL + CIGN(0.5,WALL)
  224 IF(NORIEN-10)238,225,231
  225 CALL ROTATE(K(N),L(N))
      GO TO 238
  231 CALL ROTATE(J(N),L(N))
  238 JPLMI=JZRTST(J(N))
      IF(JPLMI)239,246,242
  239 J(N) = -J(N)
  240 K(N)=-K(N)
  241 L(N)=-L(N)
      B(N)=-B(N)
  242 IF(J(N))246,243,246
  243 IF(K(N))240,244,246
  244 IF(L(N))241,246,246
  246 IF(K(N))255,251,255
  251 K(N) = 0
  255 IF(L(N))257,256,257
  256 L(N)=0
  257 IF(JMAX-J(N))247,249,249
  247 JMAX = J(N)
  249 IF(KMAX-K(N))250,252,252
  250 KMAX = K(N)
      GO TO 254
  252 IF(KMIN-K(N))254,254,253
  253 KMIN=K(N)
  254 CONTINUE
  260 NEW = NEQUIV - 1
      DO 270 NN=1,NEW
      NOW = NN+1
      DO 270 N=NOW,NEQUIV
      IF(A(NN))265,264,265
  264 IF(B(NN))265,270,265
  265 IF(J(NN)-J(N))270,266,270
  266 IF(K(NN)-K(N))270,267,270
  267 IF(L(NN)-L(N))270,268,270
  268 A(N)=0.
      B(N)=0.
  270 CONTINUE
      IF(ISST(1).NE.2) GO TO 982
C     ADJUST COEFFICIENTS FOR BOUNDED PROJECTION
      DO 985 N=1,NEQUIV
      IF(L(N).NE.0) GO TO 983
      FACTOR = DELTAZ
      GO TO 984
  983 FACTOR = 3.1415926536*L(N)
      TOP = FACTOR*DELTAZ
      FACTOR = SIN(TOP)/FACTOR
  984 A(N) = A(N)*FACTOR
      B(N) = B(N)*FACTOR
 985  CONTINUE
  982 CONTINUE
      NTRAN = 0
      DO 300 N=1,NEQUIV
      IF(A(N))298,285,298
  285 IF(B(N))298,300,298
  298 AMAX = AMAX + ABS(A(N))
      BMAX = BMAX + ABS(B(N))
      NTRAN = NTRAN+1
      JX(NTRAN)=J(N)
      KX(NTRAN)=K(N)
      LX(NTRAN)=L(N)
      AX(NTRAN)=A(N)
      BX(NTRAN)=B(N)
  300 CONTINUE
 3011 WRITE (IVXX)NTRAN
      WRITE(IVXX)(JX(N),KX(N),LX(N),AX(N),BX(N),N=1,NTRAN)
      NEXPAN = NEXPAN + NTRAN
  301 IF(NREF)201,201,302
  302 NREF = NREF - 1
  303 DO 304 N=1,NTRAN
  304 WRITE (III,305)JX(N),KX(N),LX(N),AX(N),BX(N)
      WRITE (III,306)
  311 GO TO 201
  320 WRITE (IVXX)NZERO
      ENDFILE IVXX
      REWIND IVXX
      NCD = (JMAX+1)*(KMAX-KMIN+1)*2
      NEF = (JMAX+1)*NY*2
      ASSIGN 332 TO NXIT
  329 NMEM =0
  330 READ(IVXX)NTRAN
  332 IF(NTRAN)331,348,331
  331 NMEM = NMEM + NTRAN
      IF(NMEM-24)335,335,338
  335 NPREV=NMEM-NTRAN+1
      READ (IVXX)(J(N),K(N),L(N),A(N),B(N),N=NPREV,NMEM)
      IF(NMEM-24)330,337,385
  337 READ (IVXX)NTRAN
      GO TO 340
  338 NMEM = NMEM - NTRAN +1
      DO 339 M=NMEM,24
      J(M) = 0
      K(M) = 0
      L(M) = 0
      A(M) = 0.
  339 B(M) = 0.
  340 WRITE (IXX)(J(N),K(N),L(N),A(N),B(N),N=1,24)
      NMEM=0
      GO TO NXIT,(332,350)
  348 ASSIGN 350 TO NXIT
      REWIND IVXX
      GO TO 338
  350 DO 351 N=1,24
  351 J(N) = 999
      WRITE (IXX)(J(N),N=1,24),(J(N),N=1,24), (J(N),N=1,24),
     1    (J(N),N=1,24),(J(N),N=1,24)
      REWIND IXX
      IF(NTOTAL)1000,1000,1001
 1000 WRITE(III,2000)
      STOP
 1001 IF(NEXPAN)1002,1002,1003
 1002 WRITE(III,2001)
      STOP
 1003 WRITE (III,352)NTOTAL,NEXPAN
      NEFTBL = NMEMMX-NCD
      WRITE(III,355)NCD
      IF(NEFTBL)4007,4007,3009
 3009 IF(NEFTBL-NEF)360,356,356
  356 WRITE(III,357)NEF
      GO TO 385
  360 NNN=1+(NEF/NEFTBL)
      NY = NEFTBL/(2*(JMAX+1))
      WRITE(III,361)NEFTBL,NNN
  385 RETURN
 4007 WRITE (III,4008)
91270 STOP
      END
      SUBROUTINE ROTATE(A,B)
      Z=A
      A=B
      B=Z
      RETURN
      END
      SUBROUTINE SETU(U,A,B,C,COSA,COSB,COSC)
      DIMENSION U(3,3),DPC(6),DM(3,3),RM(3,3),U1(3),U2(3),U3(3),U4(3)
      DIMENSION V(3,3)
      DPC(1)=A
      DPC(2)=B
      DPC(3)=C
      DPC(4)=COSA
      DPC(5)=COSB
      DPC(6)=COSC
      CALL STOAA(DPC,DM)
      CALL MI3(DM,RM,DETA)
      DO 10 J=1,3
      U1(J)=0.
  10  U2(J)=0.
      U1(2)=1.
      U2(3)=1.
      CALL NORM(DM,U1)
      CALL NORM(DM,U2)
      CALL CROSS(RM,U1,U2,U3)
      CALL NORM(DM,U3)
      CALL CROSS(RM,U3,U1,U4)
      CALL NORM(DM,U4)
      DO 11 I=1,3
      DO 11 J=1,3
  11  U(I,J)=0.
      DO 12 J=1,3
      U(1,J)=U3(J)
      U(2,J)=U1(J)
  12  U(3,J)=U4(J)
      CALL MI3(U,V,DETA)
      RETURN
      END
      SUBROUTINE SETUP
      DIMENSION TRGTBL(1001),ISST(20),WORDS(20)
      COMMON TRGTBL,NORIEN,NXX,NYX,NZ,XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,
     1 DX,DY,DZ,AMAX,BMAX,JMAX,KMAX,KMIN,NMEMMX,NEGINA,NCD,NEF,
     2  NEFTBL,NX,NY,NCUE,N1,RMAX,NLAST,NFPLT,YFL,N11,IN,III,IVXX,IXX,
     3  NINPUT,NN3,NDATAP,ISST,A,B,C,COSA,COSB,COSC,NSEC,NGRID,NSKIP,
     5  CNTRNO,CNTNEG,NEXPAN,WORDS
      COMMON /PETE/ RKEEP
C
      COMMON /INPUT/ NREAD,NPOINT,IRED,MODE,LINO,IDISML,
     1  ICHARS(14),ICARD(80),READIN(50)
C
      DIMENSION IREDIN(50)
C
      EQUIVALENCE (READIN(1),IREDIN(1))
C
C
  99  FORMAT(20A4)
  100 FORMAT(1H0 ,20A4/)
 2201 FORMAT(1X,20I3,F10.4)
 3011 FORMAT(4H A= ,F7.4/4H B= ,F7.4/4H C= ,F7.4/12H COS ALPHA =,F9.6/
     1  12H COS BETA = ,F9.6/12H COS GAMMA =,F9.6///)
 5012 FORMAT(28H COMPUTE A FOURIER SUMMATION)
 5013 FORMAT(1H ,27X,23H FOR BOUNDED PROJECTION)
 5020 FORMAT(18H PRINT THE RESULTS//)
 5049 FORMAT(23H0SINGLE SPACE FOURPRINT)
 5050 FORMAT(23H0DOUBLE SPACE FOURPRINT)
 5060 FORMAT(19H0LIST FOURIER PEAKS)
 5081 FORMAT(43H0THE MAXIMUM NUMBER OF PEAKS LISTED WILL BE,I4)
 5045 FORMAT(25H0PLOTTING WILL BE ENTERED)
 5102 FORMAT(34H0TRANSFORM CELL BEFORE RIP AND SIG)
34567 FORMAT(I5,2X,30HFILES SKIPPED ON INPUT TAPE 17)
 2002 FORMAT(49H0INPUT DATA GENERATED BY RIETVELD PROFILE PROGRAM)
 5205 FORMAT(52H0NEGATIVE NUMBERS REPLACED BY ZERO IN PRINTED OUTPUT)
C
C      INPUT/OUTPUT UNITS VARIABLY ASSIGNED HERE
C     IN = CARD READER                 III = LINE PRINTER
C     NDATAP = REFLECTION INPUT DATA UNIT   IXX,IVXX = SCRATCH UNITS
C      IF IVXX IS SAVED CAN ENTER WITH THIS TAPE TO PLOT OR PRINT
	CALL MFOUR1(IN,III,NDATAP,IXX,IVXX)
      NMEMMX=12000
      REWIND NDATAP
      REWIND IXX
C
C     ONLY THE FIRST 14 CONTROL INTEGERS ARE IN USE
C
      DO 201 I=15,20
      ISST(I)= 0
  201 CONTINUE
      ISST(10)= 0
C     CALCULATE COSINE TABLE (TRGTBL) FOR USE IN SIG100
  52  ARG = 0.
      DARG= 0.0062831853
      DO 15 I=1,1001
      TRGTBL(I)=COS(ARG)
  15  ARG=ARG+DARG
      TRGTBL(1)=1.
      TRGTBL(251)=0.
      TRGTBL(501)=-1.
      TRGTBL(751)=0.
      TRGTBL(1001)=1.
      READ(IN,99)(WORDS(I),I=1,20)
      WRITE(III,100)(WORDS(I),I=1,20)
       NREAD= 13
	READ(IN,*)(IREDIN(I),I=1,13)
       DO 202 I=1,9
      ISST(I)= IREDIN(I)
  202 CONTINUE
      DO 203 I= 11,14
      ISST(I)= IREDIN(I-1)
  203 CONTINUE
 	READ(IN,*) AKEEP
       WRITE(III,2201)(ISST(I),I=1,20),RKEEP                 !!      SETP
C     INPUT FROM PROFILE REFINEMENT?
      IF(ISST(12)) 50,60,50
   60 READ(NDATAP) A,B,C,COSA,COSB,COSC
      GO TO 1613
   50 IDISML= -1
      NREAD= 6
	READ(IN,*)(READIN(I),I=1,6)
      A= READIN(1)
      B= READIN(2)
      C= READIN(3)
      COSA= READIN(4)
      COSB= READIN(5)
      COSC= READIN(6)
 1613 WRITE(III,3011)A,B,C,COSA,COSB,COSC
      IF(ISST(11))5005,5005,5006
 5006 CALL CARDIN(IN,NDATAP)
 5005 IF(ISST(1))5010,5015,5010
 5010 WRITE(III,5012)
      IF(ISST(1).NE.2) GO TO 5015
      ISST(6)= 1
 5015 IF(ISST(3))5019,5053,5019
 5019 WRITE(III,5020)
      IF(ISST(6)-2)5047,5048,5047
 5047 WRITE(III,5049)
      GO TO 5053
 5048 WRITE(III,5050)
 5053 IF(ISST(4))5055,5025,5055
 5055 WRITE(III,5060)
      IF(ISST(7))5051,5051,5052
 5051 IJA=1000
      GO TO 5080
 5052 IJA=100*ISST(7)
 5080 WRITE(III,5081)IJA
 5025 IF(ISST(5))5041,1998,5041
 5041 WRITE(III,5045)
 1998 IF(ISST(12)) 11998,2001,11998
 2001 WRITE(III,2002)
11998 IF(ISST(13)) 5203,5204,5203
 5203 WRITE(III,5205)
 5204 IF(ISST(2)) 5100,5101,5100
 5100 WRITE(III,5102)
      WRITE(III,5013)
 5101 RETURN
      END
      SUBROUTINE SIG100
      DIMENSION J(24),K(24),L(24),A(24),B(24),R(1001),TABLE(12000)
      DIMENSION WORDS(20)
      COMMON TRGTBL(1001),NORIEN,NXMAX,NYMAX,NZ,XMIN,XMAX,YMIN,YMAX,
     1  ZMIN,ZMAX,DX,DY,DZ,AMAX,BMAX,JMAX,KMAX,KMIN,NMEMMX,NEGINA,NCD,
     2  NEF,NEFTBL,NX,NY,NCUE,N1,RMAX,NLAST,NFPLT,YFL,N11,IN,III,IVXX,
     2  IXX,NINPUT,NN3,NDATAP,ISST(20),AXX,BXX,C,COSA,COSB,COSC,NSEC,
     3  NGRID,NSKIP,CNTRNO,CNTNEG,NEXPAN,WORDS,TABLE
C
  122 FORMAT('0FOURIER (SIG) LEVEL = ',I4)
  441 FORMAT('0RMAX = ',E13.6////)
C
      SEV = 1000.
      ZER = 0.
      AOM7 = -1000.
      RMAX = 0.
      NJ = JMAX + 1
      NK = KMAX - KMIN + 1
      NC = NCD/2
      Z = ZMIN
      NZMAX = (( ZMAX - ZMIN)/DZ + 1.5)
      NYMAX = (( YMAX - YMIN)/DY + 1.5)
      NZ = 1
  100 DO 120 I=1,NMEMMX
  120 TABLE(I)=0.
      WRITE(III,122)NZ
  130 READ(IXX)(J(I),K(I),L(I),A(I),B(I),I=1,24)
      DO 143 I=1,24
      IF(J(I).EQ.999) GO TO 175
      LOCC = J(I)*NK + (K(I) - KMIN) + 1
      LOCD = LOCC + NC
      XL = L(I)
      XLZ = XL*Z
      CALL SINCOS(XLZ,SINLZ,COSLZ)
      TABLE(LOCC)=TABLE(LOCC) + A(I)*COSLZ + B(I)*SINLZ
      TABLE(LOCD) = TABLE(LOCD) - A(I)*SINLZ + B(I)*COSLZ
  143 CONTINUE
      GO TO 130
  175 REWIND IXX
      YI=YMIN
      YF=YMAX
  204 NY = ((YF-YI)/DY + 1.5)
      NEF = (JMAX + 1)*NY*2
      IF((NCD+NEF).LE.NMEMMX) GO TO 205
      YF = YF - DY
      GO TO 204
  205 NE = NY*NJ
      XKMIN = KMIN
      LOCEI= NCD + 1
      LOCEF = LOCEI + 2*NE - 1
      DO 206 I=LOCEI,LOCEF
  206 TABLE(I)=0.
      LOCC = 1
      LOCD = LOCC + NC
      DO 250 N=1,NJ
      RKDY = XKMIN * DY
      RKYI = XKMIN * YI
      DO 240 M=1,NK
      LOCE = LOCEI
      RKY = RKYI
      LOCF = LOCE + NE
      CHY = TABLE(LOCC)
      DHY = TABLE(LOCD)
      DO 230 I=1,NY
      CALL SINCOS(RKY,SINKY,COSKY)
      TABLE(LOCE) = TABLE(LOCE) + CHY*COSKY + DHY*SINKY
      TABLE(LOCF) = TABLE(LOCF) - CHY*SINKY + DHY*COSKY
      LOCE = LOCE + NJ
      LOCF = LOCE + NE
      RKY = RKY + RKDY
  230 CONTINUE
      RKYI = RKYI + YI
      RKDY = RKDY + DY
      LOCC = LOCC + 1
      LOCD = LOCC + NC
  240 CONTINUE
      LOCEI = LOCEI + 1
  250 CONTINUE
      NX = (( XMAX - XMIN)/DX + 1.5)
      LOCE = NCD + 1
      LOCF = LOCE + NE
      Y = YI
      WRITE(IVXX)SEV,SEV
C****************************************************************
      WRITE(IVXX)NX,NY,XMIN,XMAX,DX,ZMAX,Z,NORIEN,Y,YMAX,DY,AMAX,BMAX,
     1    DZ,ZMIN,NZ,AXX,BXX,C,COSA,COSB,COSC
      DO 380 I=1,NY
      DO 320 N=1,NX
  320 R(N) = 0.
      HDX = 0.
      HXI = 0.
      DO 360 M = 1,NJ
      E = TABLE(LOCE)
      F = TABLE(LOCF)
      HX = HXI
      DO 340 N=1,NX
      CALL SINCOS(HX,SINHX,COSHX)
      R(N) = R(N) + E*COSHX + F*SINHX
      HX = HX + HDX
  340 CONTINUE
      HDX = HDX + DX
      HXI = HXI + XMIN
      LOCE = LOCE + 1
      LOCF = LOCE + NE
  360 CONTINUE
      DO 370 N = 1,NX
      IF(ABS(R(N)).GT.RMAX) RMAX = ABS(R(N))
  370 CONTINUE
      WRITE(IVXX)ZER,ZER
      WRITE(IVXX)Y,(R(N),N=1,NX)
      Y = Y + DY
  380 CONTINUE
      IF(YF.GE.YMAX) GO TO 400
      YI = YF
      YF = YMAX
      GO TO 204
  400 Z = Z + DZ
      NZ = NZ + 1
      IF(NZ.LE.NZMAX) GO TO 100
      WRITE(IVXX)AOM7,RMAX
      WRITE(III,441)RMAX
      ENDFILE IVXX
      REWIND IVXX
      RETURN
      END
      SUBROUTINE SINCOS(ARG,SINARG,COSARG)
      COMMON TRGTBL(1001)
  5   IF(ARG.GE.0.) GO TO 10
      ARG = ARG + 1.
      GO TO 5
  10  NARG1 = (ARG*1000. + 1.5)
  11  IF(NARG1.LE.1001) GO TO 12
      NARG1 = NARG1 - 1000
      GO TO 11
  12  NARG2 = NARG1 + 250
  15  IF(NARG2.GT.1001) NARG2 = NARG2 - 1000
  20  SINARG = -TRGTBL(NARG2)
      COSARG = TRGTBL(NARG1)
      RETURN
      END
      SUBROUTINE STOAA(A,AA)
C     STORES METRIC AA FROM CELL CONSTANTS A
      DIMENSION A(6),AA(3,3)
      AA(1,1) = A(1)*A(1)
      AA(2,2) = A(2)*A(2)
      AA(3,3) = A(3)*A(3)
      AA(1,2) = A(1)*A(2)*A(6)
      AA(2,1) = AA(1,2)
      AA(1,3) = A(1)*A(3)*A(5)
      AA(3,1) = AA(1,3)
      AA(2,3) = A(2)*A(3)*A(4)
      AA(3,2) = AA(2,3)
      RETURN
      END
      SUBROUTINE TRANS(U,DETU)
      COMMON STUFF,ULIMIT,EXTRA,IN,III,IVXX,IXX,NN5,NN6,NDATAP,ISST,
     1  ACELL,ALSO,G
C
      COMMON /INPUT/ NREAD,NPOINT,IRED,MODE,LINO,IDISML,
     1  ICHARS(14),ICARD(80),READIN(50)
C
      DIMENSION STUFF(1005),ULIMIT(9),EXTRA(19),ISST(20),ACELL(6),
     1  ALSO(558),U(3,3),G(3,3),PLANE(3),GNEW(3,3),CELL(3),UINV(3,3)
C
      DIMENSION IREDIN(50)
C
      EQUIVALENCE (READIN(1),IREDIN(1))
C
  4   FORMAT(46H1TRANSFORMATION MATRIX READ FROM CARDS..A2=UA1)
  8   FORMAT(81H1TRANSFORMATION MATRIX TO OBTAIN ORTHOGONAL SYSTEM DEFIN
     1ED BY THE FOLLOWING PLANE)
   9   FORMAT(1H0,10X,F10.5,4H X +,F10.5,4H Y +,F10.5,4H Z =,F10.5)
  11  FORMAT(10H0NEW AXIS ,I2,2X,9HRUNS FROM,F10.5,2X,2HTO,F10.5,2X,
     1  11HIN STEPS OF,F10.5,2X,10HANGSTROMS.      )
  17  FORMAT(23H0NEW CELL CONSTANTS ARE ,6F12.5)
  19  FORMAT(1H0,10X,4HNEWA,I1,1H=,F12.6,5H A1 +,F12.6,5H A2 +,F12.6,
     1  5H A3  )
 1013 FORMAT(36H0THE DETERMINANT OF THE U MATRIX IS ,F15.6)
 1001 FORMAT(38H0THE MATRIX INVERSE TO U IS AS FOLLOWS)
 1012 FORMAT(1H0,10X,3F15.6)
C
      CALL STOAA(ACELL,G)
      IF(ISST(2)-1)1,2,3
  1   RETURN
    2 IBEG= 1
       NREAD= 9
 	READ(IN,*)(READIN(I),I=1,9)
      DO 96 I=1,3
      DO 95 J=1,3
      U(I,J)= READIN(3*I-3+J)
   95 CONTINUE
   96 CONTINUE
C     TRANSFORMATION MATRIX IF IT IS TO BE READ
      WRITE(III,4)
      GO TO 66
    3 NREAD= 7
 	READ(IN,*)(READIN(I),I=1,7)
      DO 97 I=1,3
      PLANE(I)= READIN(I)
      CELL(I)= READIN(I+4)
   97 CONTINUE
      DPLANE= READIN(4)
C     EQUATION OF PLANE..... SUM(PLANE(I)*X(I))=DPLANE
C     MINIMUM DIMENSIONS OF TRANSFORMED CELL
      WRITE(III,8)
      WRITE(III,9)(PLANE(I),I=1,3),DPLANE
      CALL GP1(PLANE,DPLANE,G,U)
    6 NREAD= 9
 	READ(IN,*)(READIN(I),I=1,9)
      DO 98 I=1,9
      ULIMIT(I)= READIN(I)
   98 CONTINUE
  666 DO 12 I=1,3
      WRITE(III,11)I,ULIMIT(2*I-1),ULIMIT
     1 (2*I),ULIMIT(I+6)
      ACELL(I)=AMAX1(ABS(ULIMIT(2*I-1))*2.,ABS(ULIMIT(2*I))*2.,10.,
     1  CELL(I))
      DO 20 J=1,3
  20  U(I,J) = U(I,J)*ACELL(I)
      ULIMIT(2*I-1)=ULIMIT(2*I-1)/ACELL(I)
      ULIMIT(2*I)=ULIMIT(2*I)/ACELL(I)
      ULIMIT(I+6)=ULIMIT(I+6)/ACELL(I)
  12  ACELL(I+3)=0.
      GO TO 14
  66  DO 15 I=1,3
      DO 15 J=1,3
      GNEW(I,J)=0.
      DO 15 K=1,3
      DO 15 L=1,3
  15  GNEW(I,J) = GNEW(I,J) + U(I,K)*U(J,L)*G(K,L)
      DO 16 I=1,3
  16  ACELL(I) = SQRT(GNEW(I,I))
      ACELL(4) = GNEW(1,2)/(ACELL(1)*ACELL(2))
      ACELL(5)=GNEW(1,3)/(ACELL(1)*ACELL(3))
      ACELL(6)=GNEW(2,3)/(ACELL(2)*ACELL(3))
  14  WRITE(III,17)(ACELL(I),I=1,6)
      DO 18 I=1,3
  18  WRITE (III,19)I,(U(I,J),J=1,3)
      CALL MI3(U,UINV,DETU)
      WRITE(III,1013)DETU
      WRITE(III,1001)
      WRITE(III,1012)((UINV(I,J),J=1,3),I=1,3)
      RETURN
      END
      SUBROUTINE TRIG(COS,SIN,NU)
 1170 IF(NU)1173,1201,1171
 1171 NU=NU-12                                                          TRIG
      GO TO 1170
 1173 NU = NU + 12
      IF(NU)1173,1201,1175
 1175 IF(NU-6)1176,1204,1177
01176 IF(NU-3)1209,1206,1212
 1177 IF(NU-9)1219,1214,1216
 1201 COS=1.
 1202 SIN=0.
      GO TO 1218
 1204 COS=-1.
      GO TO 1202
 1206 SIN=1.
 1207 COS=0.
      GO TO 1218
 1209 COS=.5
 1210 SIN=.866025
      GO TO 1218
 1212 COS=-.5
      GO TO 1210
 1214 SIN=-1.
      GO TO 1207
 1216 COS=.5
 1217 SIN=-.866025
 1218 RETURN
 1219 COS=-.5
      GO TO 1217
      END
      SUBROUTINE VM(A,B,C)
C     VECTOR C = VECTOR A X MATRIX B
      DIMENSION A(3),B(3,3),C(3)
      DO 2 J=1,3
      C(J)=0.
      DO 2 I=1,3
  2   C(J)=C(J)+A(I)*B(I,J)
      RETURN
      END
      FUNCTION VMV(A,B,C)
C     VMV = DOT PRODUCT OF VECTORS A AND C.  B = METRIC
      DIMENSION A(3),B(3,3),C(3)
      VMV=0.
      DO 1 I=1,3
      DO 1 J=1,3
  1   VMV = VMV + A(I)*B(I,J)*C(J)
      RETURN
      END
      SUBROUTINE CARDIN(IN,NDATAP)
      RETURN
      END
      SUBROUTINE REJECT(JJ,KK,LL,FOBS,SFCALC,COSAA,SINAA,
     1  DEL,NSKIP,AA,BB)
      NSKIP= 0
      RETURN
      END
      FUNCTION CIGN(A,B)
C     TAKES SIGN OF ZERO AS POSITIVE
      IF(B) 10,20,10
   10 C= B
      GO TO 30
   20 C= 1.0
   30 CIGN= SIGN(A,C)
      RETURN
      END
